import greenfoot.*;  // (World, Actor, GreenfootImage, Greenfoot and MouseInfo)
import java.util.List;
import java.util.ListIterator;
/**
 * Write a description of class Field here.
 * 
 * @author (your name) 
 * @version (a version number or a date)
 */
public class Field extends World
{

    /**
     * Constructor for objects of class Field.
     * 
     */
    public Box b;
    public Mover m;
    public int xPos;
    public int yPos;
    private int scrollSpeed;
    public GreenfootImage gi;
    public GreenfootImage background;
    public Field()
    {    
        // Create a new world with 600x400 cells with a cell size of 1x1 pixels.
        super(800, 750, 1, false); 
        b = new Box();
        m = new Mover();
        addObject(m, 0, 0);
        setActOrder(Mover.class, SmoothMover.class, Box.class);//very important act order. if not in this order, selecting wont work
        setPaintOrder(Actor.class, BloodSplat.class, Tracks.class);
        spawnSoldierLine(90, 100);
        spawnArmor(150, 100);
        spawnRocks();
        spawnQueenLine(1000, 500);
        Roach r = new Roach();
        addObject(r, 900, 900);
        
        gi = new GreenfootImage(800,800);
        background = new GreenfootImage("MAP.png");
        xPos = 0;
        yPos = 0;
        scrollSpeed = 4;
    }
    public void act()
    {
        if(Greenfoot.mousePressed(null) && leftClicked())
        {
            addObject(b, Greenfoot.getMouseInfo().getX(), Greenfoot.getMouseInfo().getY());
        }
        if(Greenfoot.getMouseInfo() != null)
        {
            if(Greenfoot.getMouseInfo().getX() > 700)
            {
                scrollLeft();
            }
            if(Greenfoot.getMouseInfo().getX() < 100)
            {
                scrollRight();
            }
            if(Greenfoot.getMouseInfo().getY() > 650)
            {
                scrollUp();
            }
            if(Greenfoot.getMouseInfo().getY() < 100)
            {
                scrollDown();
            }
        }
    }
    public void scrollLeft()
    {
        if(xPos > -(background.getWidth()-getWidth()-scrollSpeed))
        {
            xPos -= scrollSpeed;
            gi.drawImage(background,xPos,yPos);
            setBackground(gi);
            
            List<Actor> list = getObjects(Actor.class);
            for(int n = 0; n < list.size(); n++)
            {
                Actor a = list.get(n);
                a.setLocation(a.getX() - scrollSpeed, a.getY());
            }
            List<Moveable> list2 = getObjects(Moveable.class);
            for(int n = 0; n < list2.size(); n++)
            {
                Moveable m = (Moveable)list2.get(n);
                m.setCord(-scrollSpeed, 0);
            }
            List<SmoothMover> list3 = getObjects(SmoothMover.class);
            for(int n = 0; n < list3.size(); n++)
            {
                SmoothMover s = (SmoothMover)list3.get(n);
                s.currentX -= scrollSpeed;
            }
        }
    }
    public void scrollRight()
    {
        if(xPos < -scrollSpeed)
        {
            xPos += scrollSpeed;
            gi.drawImage(background,xPos,yPos);
            setBackground(gi);
            
            List<Actor> list = getObjects(Actor.class);
            for(int n = 0; n < list.size(); n++)
            {
                Actor a = list.get(n);
                a.setLocation(a.getX() + scrollSpeed, a.getY());
            }
            List<Moveable> list2 = getObjects(Moveable.class);
            for(int n = 0; n < list2.size(); n++)
            {
                Moveable m = (Moveable)list2.get(n);
                m.setCord(+scrollSpeed, 0);
            }
            List<SmoothMover> list3 = getObjects(SmoothMover.class);
            for(int n = 0; n < list3.size(); n++)
            {
                SmoothMover s = (SmoothMover)list3.get(n);
                s.currentX += scrollSpeed;
            }
        }
    }
    public void scrollUp()
    {
        if(yPos > -(background.getWidth()-getHeight()-scrollSpeed))
        {
            yPos -= scrollSpeed;
            gi.drawImage(background,xPos,yPos);
            setBackground(gi);
            
            List<Actor> list = getObjects(Actor.class);
            for(int n = 0; n < list.size(); n++)
            {
                Actor a = list.get(n);
                a.setLocation(a.getX(), a.getY() - scrollSpeed);
            }
            List<Moveable> list2 = getObjects(Moveable.class);
            for(int n = 0; n < list2.size(); n++)
            {
                Moveable m = (Moveable)list2.get(n);
                m.setCord(0, -scrollSpeed);
            }
            List<SmoothMover> list3 = getObjects(SmoothMover.class);
            for(int n = 0; n < list3.size(); n++)
            {
                SmoothMover s = (SmoothMover)list3.get(n);
                s.currentY -= scrollSpeed;
            }
        }
    }
    public void scrollDown()
    {
        if(yPos < -scrollSpeed)
        {
            yPos += scrollSpeed;
            gi.drawImage(background,xPos,yPos);
            setBackground(gi);
            
            List<Actor> list = getObjects(Actor.class);//moves all actor class objects(so everything)
            for(int n = 0; n < list.size(); n++)
            {
                Actor a = list.get(n);
                a.setLocation(a.getX(), a.getY() + scrollSpeed);
            }
            List<Moveable> list2 = getObjects(Moveable.class);//moveable class needs additional treatment because their dX, and dY need to change as well
            for(int n = 0; n < list2.size(); n++)
            {
                Moveable m = (Moveable)list2.get(n);
                m.setCord(0, +scrollSpeed);//adds x and y to the dX and dY
            }
            List<SmoothMover> list3 = getObjects(SmoothMover.class);//smoothMover class needs additional treatment because their currentX and currentY needs to be updated to account for the scrolling
            for(int n = 0; n < list3.size(); n++)
            {
                SmoothMover s = (SmoothMover)list3.get(n);
                s.currentY += scrollSpeed;
            }
        }
    }
    public GreenfootImage getImage()//methud required so edge detection can use the image's width and height instead of the screen's width and height
    {
        return background;
    }
    public int getActors()//for lag testing
    {
        List list = getObjects(Actor.class);
        return list.size();
    }
    public void clear()
    {
        removeObjects(getObjects(SmoothMover.class));
    }
    private boolean leftClicked()
    {
        if(Greenfoot.getMouseInfo() == null) return false;
        return Greenfoot.getMouseInfo().getButton() == 1;
    }
    private boolean rightClicked()
    {
        if(Greenfoot.getMouseInfo() == null) return false;
        return Greenfoot.getMouseInfo().getButton() == 3;
    }
    public void spawnRocks()
    {
        for(int n = 0; n < 9; n ++)
        {
            int num = Greenfoot.getRandomNumber(40) + 80;
            Rock r = new Rock(num, num);
            addObject(r, Greenfoot.getRandomNumber(1100) + 50, Greenfoot.getRandomNumber(1100) + 50);
        }
    }
    public void spawnZombie()
    {
        for(int n = 0; n < 38; n++)
        {
            Zombie z = new Zombie();
            addObject(z, Greenfoot.getRandomNumber(799), Greenfoot.getRandomNumber(350));
        }
    }
    public void spawnSoldier()
    {
        for(int n = 0; n < 13; n++)
        {
            Soldier s = new Soldier();
            addObject(s, Greenfoot.getRandomNumber(799), Greenfoot.getRandomNumber(129)+ 670);
        }
    }
    public void spawnSoldierLine(int x, int y)
    {
        for(int n = 0; n < 25; n++)
        {
            Soldier s = new Soldier();
            addObject(s, x, y);
            y += 26;
        }
    }
    public void spawnQueenLine(int x, int y)
    {
        for(int n = 0; n < 8; n++)
        {
            Queen s = new Queen();
            addObject(s, x, y);
            y += 60;
        }
    }
    public void spawnArmor(int x, int y)
    {
        int initialY = y;
        for(int n = 0; n < 3; n++)
        {
            Tank s = new Tank();
            addObject(s, x, y);
            y += 200;
        }
        y = initialY - 20;
        for(int n = 0; n < 5; n++)
        {
            Mech s = new Mech();
            addObject(s, x + 200, y);
            y += 120;
        }
    }
}
