import greenfoot.*;  // (World, Actor, GreenfootImage, Greenfoot and MouseInfo)
import java.util.List;
import java.lang.Math;
/**
 * Write a description of class Soldier here.
 * 
 * @author (your name) 
 * @version (a version number or a date)
 */
public class Mech extends Player implements Selectable
{
    /**
     * Act - do whatever the Soldier wants to do. This method is called whenever
     * the 'Act' or 'Run' button gets pressed in the environment.
     */
    private boolean selected;
    private GreenfootImage select;
    private GreenfootImage unSelect;
    private int bulletTimer;
    private int reloadTimer;
    private int sight;
    public int shootingRotation;
    public int movingRotation;
    private boolean z;//determines which gun bullet fires from
    private int clickTimer;
    private int clickCount;
    public Mech()
    {
        selected = false;
        select = new GreenfootImage("mechSelect.png");
        unSelect = new GreenfootImage("mech.png");
        bulletTimer = 7;
        reloadTimer = 0;
        Hp = 40;
        speed = 1.0;
        sight = 425;
        r = getImage().getHeight()/2 - 1;
        shootingRotation = getRotation();
        movingRotation = getRotation();
        z = false;
        mass = 15.0;
    }
    public void act() 
    {
        if(Hp <= 0)
        {
            die();
            return;
        }
        move(0.0);
        if(boxed())
        {
            select();
            if(Greenfoot.mouseClicked(null))
            {
                clickCount ++;
                clickTimer ++;
            }
        }
        else if(Greenfoot.getMouseInfo() != null && leftClicked() && clickTimer == 0)
        {
            deSelect();
        }
        if(Greenfoot.isKeyDown("s") && selected)
        {
            dX = (int)currentX;
            dY = (int)currentY;
        }
        
        if(clickTimer != 0)//begin counting
        {
            clickTimer ++;
        }
        if(clickTimer > 25)//time allowed to double click
        {
            clickTimer = 0;
            clickCount = 0;
        }
        if(clickCount == 2)//double clicked
        {
            List<Mech> list = getWorld().getObjects(Mech.class);
            for(int n = 0; n < list.size(); n ++)
            {
                list.get(n).select();
                list.get(n).clickTimer = 1;
                list.get(n).clickCount = 0;
            }
            clickTimer = 1;
            clickCount = 0;
        }
        
        if(Greenfoot.getMouseInfo() != null && selected && rightClicked())
        {
            dX = Greenfoot.getMouseInfo().getX();
            dY = Greenfoot.getMouseInfo().getY();
        }
        
        if(seeEnemy())
        {
            turnTowardsNearestEnemy();
        }
        reloadTimer += Greenfoot.getRandomNumber(2)+1;
    }    
    public Cord getGunPoint()
    {
        int d = r;//how far from the center
        double angle = Math.toRadians(getRotation());//angle offset
        double initialAngle = Math.PI/6;//initial angle
        int x = (int)Math.round(getX() + d*Math.cos(angle-initialAngle));
        int y = (int)Math.round(getY() + d*Math.sin(angle-initialAngle));
        Cord c = new Cord(x, y);
        z = true;
        return c;
    }
    public Cord getGunPoint2()
    {
        int d = r;//how far from the center
        double angle = Math.toRadians(getRotation());//angle offset
        double initialAngle = Math.PI*11/6;//initial angle
        int x = (int)Math.round(getX() + d*Math.cos(angle-initialAngle));
        int y = (int)Math.round(getY() + d*Math.sin(angle-initialAngle));
        Cord c = new Cord(x, y);
        z = false;
        return c;
    }
    public void turnTowardsNearestEnemy()
    {
        List<Enemy> list = getObjectsInRange(sight, Enemy.class);
        int size = list.size();
        int distance = sight;
        int x = getX();
        int y = getY();
        if(!list.isEmpty())
        {
            Enemy e = list.get(0);
            for(int n = 0; n < size; n++)
            {
                int x2 = list.get(n).getX();
                int y2 = list.get(n).getY();
                int d = (int)Math.sqrt((Math.pow((x2 - x), 2) + Math.pow((y2 - y), 2)));
                if(d < distance)
                {
                    e = list.get(n);
                    distance = d;
                }
            }
            smoothTurnTowards(e.getX(), e.getY(), 2);
            shootingRotation = getRotation();
            Killable a = (Killable)e;
            shoot(a);
        }
    }
    
    public void shoot(Killable e)
    {
        if(reloadTimer > bulletTimer)
        {
            World w = getWorld();
            MuzzleFlash f = new MuzzleFlash(15,15,30);
            Bullet b = new Bullet();
            b.setRotation(getRotation() + (Greenfoot.getRandomNumber(8)-4));
            f.setRotation(getRotation());
            
            Cord c = new Cord(0, 0);
            if(z)
            {
                c = getGunPoint2();
            }
            else
            {
                c = getGunPoint();
            }
            w.addObject(f, c.x, c.y);
            w.addObject(b, c.x, c.y);
            reloadTimer = 0;
        }
    }
    public boolean seeEnemy()
    {
        List list = getObjectsInRange(sight, Enemy.class);
        return !list.isEmpty();
    }
    public void addedToWorld(World world)  
    {  
        currentX = getX();  
        currentY = getY();  
        dX = getX();
        dY = getY();
    }  
    public void select()
    {
        selected = true;
        setImage(select);
    }
    public void deSelect()
    {
        selected = false;
        setImage(unSelect);
    }
    public boolean boxed()
    {
        Actor a = getOneIntersectingObject(Box.class);
        return a != null;
    }
    private boolean leftClicked()
    {
        return Greenfoot.getMouseInfo().getButton() == 1;
    }
    private boolean rightClicked()
    {
        return Greenfoot.getMouseInfo().getButton() == 3;
    }
    public void move()
    {
        if(!atDestination())
        {
            Field w = (Field)getWorld();
            
            turnTowards(dX, dY);
            int angle = getRotation();
            setRotation(movingRotation);
            smoothTurnTowards(dX, dY, 3);
            movingRotation = getRotation();
            if(movingRotation > angle - 10 && movingRotation < angle + 10)
            {
                move(speed);
            }
            if(currentX-w.xPos > w.getImage().getWidth()-r)
            {
                currentX -= speed;
            }
            else if(currentX-w.xPos <= r)
            {
                currentX += speed;
            }
            if(currentY-w.yPos > w.getImage().getHeight()-r)
            {
                currentY -= speed;
            }
            else if(currentY-w.yPos <= r)
            {
                currentY += speed;
            }
            setLocation((int)currentX, (int)currentY);
        }
        if(seeEnemy())
        {
            setRotation(shootingRotation);
        }
    }
}