import greenfoot.*;  // (World, Actor, GreenfootImage, Greenfoot and MouseInfo)
import java.util.List;
public class Queen extends Enemy
{
    private int eggTimer;
    private int moveTimer;
    public int sight;
    public Queen()
    {
        setRotation(Greenfoot.getRandomNumber(359));
        Hp = 200;
        eggTimer = 0;
        dX = 0;
        dY = 0;
        moveTimer = 0;
        speed = 0.5;
        r = getImage().getWidth()/2;
        mass = 100.0;
        sight = 550;
    }
    public void act() 
    {
        if(Hp <= 0)
        {
            die();
            return;
        }
        if(eggTimer > 300)
        {
            layEggs();
            eggTimer = 0;
        }
        if(moveTimer > 100)
        {
            Field w = (Field)getWorld();
            dX = Greenfoot.getRandomNumber((w.getWidth() - 2*r)+(w.getImage().getWidth()-w.getWidth()-r))+ (w.xPos + r) +r;
            dY = Greenfoot.getRandomNumber((w.getHeight() - 2*r)+(w.getImage().getWidth()-w.getWidth()-r))+ (w.yPos + r) +r;
            moveTimer = 0;
        }
        if(!atDestination())
        {
            smoothTurnTowards(dX, dY, 1);
        }
        else if(!seePlayer())
        {
            Field w = (Field)getWorld();
            dX = Greenfoot.getRandomNumber((w.getWidth() - 2*r)+(w.getImage().getWidth()-w.getWidth()-r))+ (w.xPos + r) +r;
            dY = Greenfoot.getRandomNumber((w.getHeight() - 2*r)+(w.getImage().getWidth()-w.getWidth()-r))+ (w.yPos + r) +r;
        }
        eggTimer ++;
        moveTimer ++;
    }    
    private Cord eggPoint()
    {
        int d = r;//how far from the center
        double angle = Math.toRadians(getRotation());//angle offset
        double initialAngle = Math.PI;//initial angle
        int x = (int)Math.round(getX() + d*Math.cos(angle-initialAngle));
        int y = (int)Math.round(getY() + d*Math.sin(angle-initialAngle));
        Cord c = new Cord(x, y);
        return c;
    }
    public void layEggs()
    {
        World w = getWorld();
        int n = 1;
        Cord c = eggPoint();
        for(int i = 0; i < n; i ++)
        {
            Egg e = new Egg();
            w.addObject(e, c.x, c.y);
        }
    }
    public void die()//overwrite
    {
        World w = getWorld();
        BloodSplat b = new BloodSplat(r*3,r*3);
        w.addObject(b, (int)currentX, (int)currentY);
        w.removeObject(this);
    }
    public boolean seePlayer()
    {
        List<Player> list = getObjectsInRange(sight, Player.class);
        return !list.isEmpty();
    }
}
