import greenfoot.*;  // (World, Actor, GreenfootImage, Greenfoot and MouseInfo)  
import java.lang.Math;  
/** 
 * move in double 
 *  
 * @author RUMMAKER  
 * @version 1.0 
 */
public class SmoothMover extends Actor  
{  
    public double currentX;  
    public double currentY;  
    public void addedToWorld(World world)  
    {  
        currentX = getX();  
        currentY = getY();  
    }  
  
    public void move(double speed)  
    {  
        int angle = getRotation();  
        double vectorX = Math.cos(((double)angle)*Math.PI/180.0)*(double)speed;  
        double vectorY = Math.sin(((double)angle)*Math.PI/180.0)*(double)speed; 
  
        if(isInsideWorld(currentX+vectorX, currentY+vectorY))
        {
  
            currentX += vectorX;  
            currentY += vectorY;  
            setLocation((int)currentX, (int)currentY);  
        }
    }  
  
    private boolean isInsideWorld(double x, double y)  
    {  
        Field w = (Field)getWorld();
        if ((int)x-w.xPos <= 0 || (int)x >= w.getImage().getWidth()-1) return false;  
        if ((int)y-w.yPos <= 0 || (int)y >= w.getImage().getHeight()-1) return false;  
        return true;  
    }  
    
    public void smoothTurnTowards(int x, int y, int turnSpeed)
    {
        int angle = getRotation();
        turnTowards(x, y);
        int newAngle = getRotation();
        setRotation(angle);
        
        int turnDegree = newAngle - angle;
        int pos = turnDegree;
        if(pos < 0)
        {
            pos *= -1;
        }
        if(turnSpeed > pos)//will over turn
        {
            turnSpeed = pos;
        }
        if(turnDegree < 180 && turnDegree > 0)
        {
            setRotation(angle + turnSpeed);
        }
        else if(turnDegree >= 180)
        {
            setRotation(angle - turnSpeed);
        }
        else if(turnDegree > -180 && turnDegree < 0)
        {
            setRotation(angle - turnSpeed);
        }
        else if(turnDegree <= -180)
        {
            setRotation(angle + turnSpeed);
        }
    }
    public void smoothTurnTowards(int angle, int turnSpeed)
    {
        int a = getRotation();
        
        int turnDegree = angle - a;
        int pos = turnDegree;
        if(pos < 0)
        {
            pos *= -1;
        }
        if(turnSpeed > pos)//will over turn
        {
            turnSpeed = pos;
        }
        if(turnDegree < 180 && turnDegree > 0)
        {
            setRotation(a + turnSpeed);
        }
        else if(turnDegree >= 180)
        {
            setRotation(a - turnSpeed);
        }
        else if(turnDegree > -180 && turnDegree < 0)
        {
            setRotation(a - turnSpeed);
        }
        else if(turnDegree <= -180)
        {
            setRotation(a + turnSpeed);
        }
    }
}  
