import greenfoot.*;  // (World, Actor, GreenfootImage, Greenfoot and MouseInfo)
import java.util.List;
/**
 * Write a description of class Tank here.
 * 
 * @author (your name) 
 * @version (a version number or a date)
 */
public class Tank extends Player implements Selectable
{
    /**
     * Act - do whatever the Tank wants to do. This method is called whenever
     * the 'Act' or 'Run' button gets pressed in the environment.
     */
    private TankGun gun;
    private boolean selected;
    private GreenfootImage select;
    private GreenfootImage unSelect;
    private int sight;
    private int trackTimer;
    
    private int clickTimer;
    private int clickCount;
    public Tank()
    {
        gun = new TankGun();
        selected = false;
        select = new GreenfootImage("tankSelect.png");
        unSelect = new GreenfootImage("tank.png");
        Hp = 100;
        speed = 0.9;
        sight = 660;
        r = getImage().getWidth()/2;
        mass = 20.0;
        trackTimer = 0;
    }
    public void act() 
    {
        positionGun();
        if(Hp <= 0)
        {
            die();
            return;
        }
        if(boxed())
        {
            select();
            if(Greenfoot.mouseClicked(null))
            {
                clickCount ++;
                clickTimer ++;
            }
        }
        else if(Greenfoot.getMouseInfo() != null && leftClicked() && clickTimer == 0)
        {
            deSelect();
        }
        if(Greenfoot.isKeyDown("s") && selected)
        {
            dX = (int)currentX;
            dY = (int)currentY;
        }
        
        if(clickTimer != 0)//begin counting
        {
            clickTimer ++;
        }
        if(clickTimer > 25)//time allowed to double click
        {
            clickTimer = 0;
            clickCount = 0;
        }
        if(clickCount == 2)//double clicked
        {
            List<Tank> list = getWorld().getObjects(Tank.class);
            for(int n = 0; n < list.size(); n ++)
            {
                list.get(n).select();
                list.get(n).clickTimer = 1;
                list.get(n).clickCount = 0;
            }
            clickTimer = 1;
            clickCount = 0;
        }
        
        if(Greenfoot.getMouseInfo() != null && selected && rightClicked())
        {
            dX = Greenfoot.getMouseInfo().getX();
            dY = Greenfoot.getMouseInfo().getY();
        }
        if(seeEnemy())
        {
            turnTowardsNearestEnemy();
        }
        else
        {
            gun.smoothTurnTowards(getRotation(), 2);
        }
        trackTimer ++;
    }    
    public void move()//overwrite
    {
        if(!atDestination())
        {
            Field w = (Field)getWorld();
            smoothTurnTowards(dX, dY, 2);
            
            if(trackTimer > 6)
            {
                Tracks t = new Tracks();
                t.setRotation(getRotation());
                w.addObject(t, (int)currentX, (int)currentY);
                trackTimer = 0;
            }
            
            move(speed);
            if(currentX-w.xPos > w.getImage().getWidth()-r)
            {
                currentX -= speed;
            }
            else if(currentX - w.xPos <= r)
            {
                currentX += speed;
            }
            if(currentY-w.yPos > w.getImage().getHeight()-r)
            {
                currentY -= speed;
            }
            else if(currentY - w.yPos <= r)
            {
                currentY += speed;
            }
            setLocation((int)currentX, (int)currentY);
        }
    }
    public void positionGun()
    {
        int d = 5;//how far from the center
        double angle = Math.toRadians(getRotation());//angle offset
        double initialAngle = Math.PI;//initial angle
        int x = (int)Math.round(getX() + d*Math.cos(angle-initialAngle));
        int y = (int)Math.round(getY() + d*Math.sin(angle-initialAngle));
        gun.setLocation(x, y);
        gun.currentX = x;
        gun.currentY = y;
    }
    public void addedToWorld(World world)  
    {  
        currentX = getX();  
        currentY = getY();  
        dX = getX();
        dY = getY();
        world.addObject(gun, getX(), getY());
        positionGun();
    }  
    public void select()
    {
        selected = true;
        setImage(select);
    }
    public void deSelect()
    {
        selected = false;
        setImage(unSelect);
    }
    public boolean boxed()
    {
        Actor a = getOneIntersectingObject(Box.class);
        return a != null;
    }
    private boolean leftClicked()
    {
        return Greenfoot.getMouseInfo().getButton() == 1;
    }
    private boolean rightClicked()
    {
        return Greenfoot.getMouseInfo().getButton() == 3;
    }
    public void turnTowardsNearestEnemy()
    {
        List<Enemy> list = getObjectsInRange(sight, Enemy.class);
        int size = list.size();
        int distance = sight;
        int x = getX();
        int y = getY();
        
        Enemy e = null;
        for(int n = 0; n < size; n++)
        {
            int x2 = list.get(n).getX();
            int y2 = list.get(n).getY();
            int d = (int)Math.sqrt((Math.pow((x2 - x), 2) + Math.pow((y2 - y), 2)));
            if(d < distance && d > 130)//130 is minimum range
            {
                e = list.get(n);
                distance = d;
            }
        }
        if(e != null)
        {
            gun.smoothTurnTowards(e.getX(), e.getY(), 3);
            int currentAngle = gun.getRotation();
            gun.turnTowards(e.getX(), e.getY());
            int finalAngle = gun.getRotation();
            gun.setRotation(currentAngle);
            if(currentAngle < finalAngle + 10 && currentAngle > finalAngle - 10)
            gun.shoot(e);
        }
    }
    public boolean seeEnemy()
    {
        List list = getObjectsInRange(sight, Enemy.class);
        return !list.isEmpty();
    }
    public void die()//overwrite
    {
        World w = getWorld();
        w.removeObject(gun);
        w.removeObject(this);
    }
}