import greenfoot.*;  // (World, Actor, GreenfootImage, Greenfoot and MouseInfo)
import java.util.List;
import java.util.ListIterator;

public class Zombie extends Enemy
{
    private int attackTimer;
    private int[] num;
    private final int CANATTACK;
    public Zombie()
    {
        setRotation(Greenfoot.getRandomNumber(359));
        Hp = 22;
        speed = 1.5;
        attackTimer = 0;
        r = getImage().getHeight()/2;
        dX = Greenfoot.getRandomNumber(700) + 50;
        dY = Greenfoot.getRandomNumber(650) + 50;
        mass = 2.0;
        num = new int[]{0,1};
        CANATTACK = 7;
    }
    public void act() 
    {
        if(Hp <= 0)
        {
            die();
            return;
        }
        damagePlayer(1);
        animate();
        action();//turn to player, else if, turn to muzzleflash, else wonder around
        attackTimer ++;
    }    
    public void action()//turn towards nearest player
    {
        List<Player> list = getObjectsInRange(400, Player.class);
        int size = list.size();
        int distance = 400;
        int x = getX();
        int y = getY();
        if(!list.isEmpty())
        {
            Player e = list.get(0);
            for(int n = 0; n < size; n++)
            {
                int x2 = list.get(n).getX();
                int y2 = list.get(n).getY();
                int d = (int)Math.sqrt((Math.pow((x2 - x), 2) + Math.pow((y2 - y), 2)));
                if(d < distance)
                {
                    e = list.get(n);
                    distance = d;
                }
            }
            smoothTurnTowards(e.getX(), e.getY(), 4);
        }
        else
        {
            turnTowardMuzzleFlash();
        }
    }
    public void turnTowardMuzzleFlash()//turn toward nearest muzzleflash
    {
        List<MuzzleFlash> list = getWorld().getObjects(MuzzleFlash.class);
        int size = list.size();
        int x = getX();
        int y = getY();
        int distance = 800;
        if(!list.isEmpty())
        {
            MuzzleFlash e = list.get(0);
            for(int n = 0; n < size; n++)
            {
                int x2 = list.get(n).getX();
                int y2 = list.get(n).getY();
                int d = (int)Math.sqrt((Math.pow((x2 - x), 2) + Math.pow((y2 - y), 2)));
                if(d < distance)
                {
                    e = list.get(n);
                    distance = d;
                }
            }
            smoothTurnTowards(e.getX(), e.getY(), 1);
        }
        else
        {
            wonder();
        }
    }
    public void wonder()
    {
        if(!atDestination())
        {
            smoothTurnTowards(dX, dY, 1);
        }
        else
        {
            Field w = (Field)getWorld();
            dX = Greenfoot.getRandomNumber((w.getWidth() - 2*r)+(w.getImage().getWidth()-w.getWidth()-r))+ (w.xPos + r) +r;
            dY = Greenfoot.getRandomNumber((w.getHeight() - 2*r)+(w.getImage().getWidth()-w.getWidth()-r))+ (w.yPos + r) +r;
        }
    }
    public void damagePlayer(int i)
    {
        List<Killable> list = getIntersectingObjects(Player.class);
        if(!list.isEmpty() && attackTimer >= CANATTACK)//list not empty and can attack
        {
            for(int n = 0; n < list.size(); n ++)//go through every object
            {
                list.get(n).takeDamage(i);
                attackTimer = 0;
            }
        }
    }
    public void animate()
    {
        if(attackTimer >= CANATTACK/2)
        {
            setImage("enemy" + num[1] + ".png");
        }
        else
        {
            setImage("enemy" + num[0] + ".png");
        }
    }
    public void die()//overwrite
    {
        World w = getWorld();
        BloodSplat b = new BloodSplat((int)(r*3.5),(int)(r*3.5));
        w.addObject(b, getX(), getY());
        w.removeObject(this);
    }
}
